import pandas as pd
import re


brand_variants = {
    'BURKERT CONTROMATIC':'BURKERT',
    'EATON BUSSMANN SERIES':'EATON',
    'FLEXLINK SYSTEMS':'FLEXLINK',
    'GRUNDFOSS':'GRUNDFOS',
    'HAYLEYS':'HAYLEY',
    'HONEYWELL HOMES':'HONEYWELL',
    'HONEYWELL ICT':'HONEYWELL',
    'LABFACILITY':'LAB FACILITY',
    'NSK-RHP':'RHP',
    '3M AQUA-PURE':'3M',
    '3M CUBITRON II':'3M',
    '3M DBI-SALA':'3M',
    '3M EAR':'3M',
    '3M GROUP':'3M',
    '3M PELTOR':'3M',
    '3M PROTECTA':'3M',
    '3M SCOTCH':'3M',
    '3M SPEEDGLAS':'3M',
    '3M WATER FILTRATION PRODUCTS':'3M',
    '4 D SYSTEMS':'4D SYSTEMS',
    'A & K SERVICES':'A&K',
    'A & M ZOBLITZ':'A&M',
    'A&S FERSA':'A&S',
    'A.M.Y. ENGINEERING LTD':'A.M.Y. ENGINEERING',
    'AB ELECTRONIC':'AB ELEKTRONIK',
    'ABB BUSCH-JAEGER':'ABB',
    'ABB CONTROL GEAR':'ABB',
    'ABB ELEKTRO ISOLIERWERKE':'ABB',
    'ABB INC':'ABB',
    'ABB JOKAB':'ABB',
    'ABB LTD GBCON':'ABB',
    'ABB STOTZ-KONTAKT':'ABB',
    'ABC CONVEYOR BELTING LTD':'ABC',
    'ABECO TOOLS':'ABECO',
    'ABEX POWER COMPONENTS LTD':'ABEX',
    'ABUS UK':'ABUS',
    'ACCRAPLY INC':'ACCRAPLY',
    'ACCURIDE INTERNATIONAL':'ACCURIDE',
    'ACE CO LTD':'ACE',
    'ACE CONTROLS':'ACE',
    'ACE CONTROLS UK':'ACE',
    'ACE DECELERATION & VIBRATION':'ACE',
    'ACE GAS SPRINGS':'ACE',
    'ACE HYDRAULICS':'ACE',
    'ACE SOUND':'ACE',
    'ACER PERIPHERALS':'ACER',
    'ACLA WERKE':'ACLA',
    'ACMI SPA':'ACMI',
    'ACMI UK LIMITED':'ACMI',
    'ACORN / LJB':'ACORN',
    'ACORN IND':'ACORN',
    'ACORN INDUSTRIAL':'ACORN',
    'ACORN INDUSTRIAL  SERVICES LTD':'ACORN',
    'ACORN INDUSTRIAL FIFE':'ACORN',
    'ACORN INDUSTRIAL SERVICES':'ACORN',
    'ACORN INDUSTRIAL SERVICES LTD':'ACORN',
    'ACORN INDUSTRIAL SERVICES LTD,':'ACORN',
    'ACORN/ANTIFRICTION':'ACORN',
    'ACORN-IND':'ACORN',
    'ACORN-RENOLD':'ACORN',
    'ACTION PLAS':'ACTIONPLAST',
    'ACTION SEALS LTD':'ACTION SEALS',
    'ACTIONPLAS':'ACTIONPLAST',
    'ACTIONPLAS LTD':'ACTIONPLAST',
    'ACTIVE KEY GMBH':'ACTIVE KEY',
    'ADAMS LUBRICATION':'ADAMS',
    'ADAPTERFLEX':'ADAPTAFLEX',
    'ADAPTOFLEX':'ADAPTAFLEX',
    'ADVANCE TAPES INTERNATIONAL':'ADVANCE TAPES',
    'ADVANCED DYNAMICS':'ADVANCED',
    'ADVANCED MAINTENANCE':'ADVANCED',
    'ADVANCED TAPES':'ADVANCE TAPES',
    'ADVANCED VACUUM':'ADVANCED',
    'AERO-MOTIVE':'AEROMOTIVE',
    'AESSEAL - NEW':'AESSEAL',
    'AEW MAREL':'AEW',
    'AHLSTROM':'AHLSTROM PUMPS',
    'AIR ACCESSORIES':'AIR',
    'AIR BENC':'AIR',
    'AIR CONTROL':'AIR',
    'AIR DUSTER':'AIR',
    'AIR ENERGY':'AIR',
    'AIR FILTERS':'AIR',
    'AIR FORCE':'AIR',
    'AIR LIQIUDE':'AIR',
    'AIR LIQUIDE':'AIR',
    'AIR LOGIC':'AIR',
    'AIR PRO':'AIR',
    'AIR PUMP':'AIR',
    'AIR PUMP & TOOL':'AIR',
    'AIR TORQUE':'AIR',
    'AIR TUF':'AIR',
    'AIRPOT SUPPLIED BY WESSEX FLUI':'AIRPOT',
    'ALAN BRADLEY':'ALLEN BRADLEY',
    'ALFA - LAVAL':'ALFA LAVAL',
    'ALFA GOMMA':'ALFAGOMMA',
    'ALFA LAVAL CORP AB':'ALFA LAVAL',
    'ALFA LAVAL FLOW':'ALFA LAVAL',
    'ALFA LAVALL':'ALFA LAVAL',
    'ALFA LAVEL':'ALFA LAVAL',
    'ALLAN BRADLEY':'ALLEN BRADLEY',
    'ALLEGRO MICROSYSTEMS':'ALLEGRO',
    'ALLEN AIR':'ALLENAIR',
    'ALLEN BADLEY':'ALLEN BRADLEY',
    'ALLEN BRADLE':'ALLEN BRADLEY',
    'ALLEN BRADLEY (320000)':'ALLEN BRADLEY',
    'ALLEN BRADLEY GUARDMASTER':'ALLEN BRADLEY',
    'ALLEN BRADLEY/ROCKEWELL':'ALLEN BRADLEY',
    'ALLEN BRADLEYAB':'ALLEN BRADLEY',
    'ALLEN CODING SYSTEMS':'ALLEN CODING',
    'ALLENBRADLEY':'ALLEN BRADLEY',
    'ALLEN-BRADLEY':'ALLEN BRADLEY',
    'ALLENWEST':'ALLEN WEST',
    'ALLTRADE INTERNATIONAL':'ALLTRADE',
    'ALLWEILLER':'ALLWEILER',
    'ALPA LAVAL':'ALFA LAVAL',
    'ALPHA ADHESIVES':'ALPHA',
    'ALPHA ADHESIVES & SEALANTS':'ALPHA',
    'ALPHA SAM':'ALPHA',
    'ALPHA SOLWAY':'ALPHA',
    'ALPHA WIRE':'ALPHA',
    'ALPHA-SAM PPE':'ALPHA',
    'ALPHASEAL':'ALPHA',
    'ALPS ALPINE':'ALPS',
    'ALPS ELECTRIC':'ALPS',
    'ALSTOM POWER':'ALSTOM',
    'ALTECH CORPORATION':'ALTECH',
    'AMERAAL BELTECH':'AMMERAAL BELTECH',
    'AMETEK LAMB':'AMETEK',
    'AMMAERAAL':'AMMERAAL BELTECH',
    'AMMEEAAL':'AMMERAAL BELTECH',
    'AMMERAAL':'AMMERAAL BELTECH',
    'AMMERAAL BELTEC':'AMMERAAL BELTECH',
    'AMMERAALBELTECH':'AMMERAAL BELTECH',
    'AMMERAL':'AMMERAAL BELTECH',
    'AMMERAL BELTECH':'AMMERAAL BELTECH',
    'AMMERALL':'AMMERAAL BELTECH',
    'AMMERALL BELTECH':'AMMERAAL BELTECH',
    'AMPHENOL FCI':'AMPHENOL',
    'AMPHENOL SOCAPEX':'AMPHENOL',
    'AMPHENOL SOCAPEX DOLE':'AMPHENOL',
    'ANDERSON POWER PRODUCTS':'ANDERSON POWER',
    'ANDRONBINAR':'ANDRON',
    'ANDRONWATERJET':'ANDRON',
    'ANSEL':'ANSELL',
    'ANSELL EDMONT':'ANSELL',
    'ANSELL GLOVES':'ANSELL',
    'ANSELL GOLDEN NEEDLES':'ANSELL',
    'ANSELL HEALTHCARE':'ANSELL',
    'ANSELL HYFLEX':'ANSELL',
    'ANSELL LIGHTING':'ANSELL',
    'ANSELL VIRTEX':'ANSELL',
    'ANSET IWATA':'ANEST IWATA',
    'ANTI FRICTION':'ANTIFRICTION',
    'ANTIFRICTION COMPONENTS':'ANTIFRICTION',
    'ANTIFRICTTION':'ANTIFRICTION',
    'ANTRIFRICTION':'ANTIFRICTION',
    'APEM COMPONENTS':'APEM',
    'APEX BELTING':'APEX',
    'APEX DYNAMICS':'APEX',
    'APEX HYDRAULICS':'APEX',
    'APEX PUMPS':'APEX',
    'APEX STAINLESS FASTENERS':'APEX',
    'APW WYOTT':'APW',
    'ARC0':'ARCO',
    'ARCO-ELECTRIC':'ARCOLECTRIC',
    'ARCOL OHMITE':'ARCOL',
    'ARCOLECTRIC SWITCHES':'ARCOLECTRIC',
    'ARCOUK':'ARCO',
    'ARROW CHEMICALS':'ARROW',
    'ARROW CLEANING AND HYGIENE SOLUTIONS':'ARROW',
    'ARROW ELECTRONICS':'ARROW',
    'ARROW FASTENER':'ARROW',
    'ARROW FASTENING':'ARROW',
    'ARROW INTEL':'ARROW',
    'ARROW SHEDS':'ARROW',
    'ARTESYN EMBEDDED TECHNOLOGIES':'ARTESYN',
    'ARTESYN TECHNOLOGIES':'ARTESYN',
    'ASAHI NOT ALLOWED':'ASAHI',
    'ASAHI SEIKO':'ASAHI',
    'ASAHI-AMERICA':'ASAHI',
    'ASAHIJ':'ASAHI',
    'ASCO JOUCOMATIC':'ASCO',
    'ASCO NUMATICS':'ASCO',
    'ASHTON':'ASHTON SEALS',
    'ASSMANN ELECTRONICS':'ASSMANN',
    'ASSMANN WSW':'ASSMANN',
    'ATLAS BALL':'ATLAS',
    'ATLAS CONVERTING EQUIPTMENT':'ATLAS',
    'ATLAS COPCO':'ATLAS',
    'ATLAS FILTRI':'ATLAS',
    'ATLAS WORKHOLDERS':'ATLAS',
    'ATP INSTRUMENTATION':'ATP',
    'AUTOMATIO':'AUTOMATION',
    'AUTOMOTION':'AUTOMATION',
    'AVENTI':'AVENTICS',
    'AVENTICSREXROTH':'AVENTICS',
    'BACO METAL CENTRES':'BACO',
    'BACOU-DALLOZ':'BACOU',
    'BACOU-DALLOZ IBERICA':'BACOU',
    'BAHCO TOOLS':'BAHCO',
    'BALLUFF MULTISWITCH':'BALLUFF',
    'BAMULLER':'BAUMULLER',
    'BANDO DENSEN':'BANDO',
    'BANDO STS':'BANDO',
    'BANDO SYNCH':'BANDO',
    'BANDO SYNCHRONOUS':'BANDO',
    'BANNER STAKES':'BANNER',
    'BANNERMA':'BANNER',
    'BARNWELL':'M BARNWELL',
    'BARTON STORAGE SYSTEMS':'BARTON',
    'BAUMER ELECTRIC':'BAUMER',
    'BAUMER IVO':'BAUMER',
    'BAUSCH & STROBE':'BAUSCH & STROBEL',
    'BAUSCH & STROBER':'BAUSCH & STROBEL',
    'BAUSCH & STROEBEL':'BAUSCH & STROBEL',
    'BAUSCH STROBEL':'BAUSCH & STROBEL',
    'BELDEN CABLE':'BELDEN',
    'BELDEN CDT':'BELDEN',
    'BELDEN LUMBERG':'BELDEN',
    'BELKIN COMPONENTS':'BELKIN',
    'BELL GEAR':'BELL',
    'BELL GEARS':'BELL',
    'BELL LIGHTING':'BELL',
    'BELZONA POLYMERICS':'BELZONA',
    'BERNSTEIN AG':'BERNSTEIN',
    'BERNSTEIN TOOLS FOR ELECTRONICS':'BERNSTEIN',
    'BERNSTEIN WERKZEUGFABRIK':'BERNSTEIN',
    'BLACKHAWK BY PROTO':'BLACKHAWK',
    'BLUE PRINT':'BLUEPRINT',
    'BM POLYCO SA':'BM POLYCO',
    'BONFIGIOLI':'BONFIGLIOLI',
    'BONFIGLIOI':'BONFIGLIOLI',
    'BONFIGLIOLIA':'BONFIGLIOLI',
    'BONFIGLIONI':'BONFIGLIOLI',
    'BONFIGLOLI':'BONFIGLIOLI',
    'BOSC':'BOSCH',
    'BOSCH - REXROTH':'BOSCH',
    'BOSCH / REXROTH':'BOSCH',
    'BOSCH AUTOMOTIVE':'BOSCH',
    'BOSCH FLUID':'BOSCH',
    'BOSCH GMGH':'BOSCH',
    'BOSCH PACKAGING':'BOSCH',
    'BOSCH PACKAGING TECHNOLOGY':'BOSCH',
    'BOSCH PKGNG TECHLGY (2315ZB)':'BOSCH',
    'BOSCH PNEUMATICS':'BOSCH',
    'BOSCH POWER TOOLS':'BOSCH',
    'BOSCH REXROTH':'BOSCH',
    'BOSCH REXROTH AG':'BOSCH',
    'BOSCH REXROTH AG (RRL)':'BOSCH',
    'BOSCH REXROTH LINEAR':'BOSCH',
    'BOSCH REXROTH LTD (PNEUMATICS)':'BOSCH',
    'BOSCH REXROTH OIL CONTROL':'BOSCH',
    'BOSCH ROBERT':'BOSCH',
    'BOSCH SECURITY SYSTEMS':'BOSCH',
    'BOSCH SENSORTEC':'BOSCH',
    'BOSCH SIGPACK':'BOSCH',
    'BOSCHE':'BOSCH',
    'BOSCH-REXROTH':'BOSCH',
    'BOSS INDUSTRIAL MOULDINGS':'BOSS INDUSTRIAL',
    'BOTT EQUIPMENT':'BOTT',
    'BOURNS ELECTRONICS':'BOURNS',
    'BRAD HARRIS':'BRAD HARRISON',
    'BRADMAN LAK':'BRADMAN LAKE',
    'BRADY SPC ABSORBENTS':'BRADY',
    'BRAMER':'BRAMMER',
    'BRAMME':'BRAMMER',
    'BRAN LUEBBE':'BRAN & LUEBBE',
    'BRANDED':'Unbranded',
    'BREC FLEX':'BRECOFLEX',
    'BRECOFELX':'BRECOFLEX',
    'BRENNENSTHUL':'BRENNENSTUHL',
    'BRIDGETEK PTE':'BRIDGETEK',
    'BRIGHTON BEST':'BRIGHTON-BEST',
    'BRILLOPACK':'BRILLOPAK',
    'BRITISH STEEL CBINET DRAWING':'BRITISH STEEL',
    'BROADCOM PI':'BROADCOM',
    'BROADERSEN':'BRODERSEN',
    'BRODERSEN CONTROLS':'BRODERSEN',
    'BRODERSEN SYSTEMS':'BRODERSEN',
    'BRODERSON':'BRODERSEN',
    'BROOK COMPTON':'BROOK CROMPTON',
    'BROOK CROMPTPN':'BROOK CROMPTON',
    'BROOK CROMTON':'BROOK CROMPTON',
    'BROOK HANSE':'BROOK HANSEN',
    'BROOK HANSON':'BROOK HANSEN',
    'BROTHER INDUSTRIES':'BROTHER',
    'BSS (UK) LTD.':'BSS',
    'BUCK & HICKMA':'BUCK & HICKMAN',
    'BUCK HICKMAN':'BUCK & HICKMAN',
    'BUCK HICKMAN INONE':'BUCK & HICKMAN',
    'BUCKHICKMAN INONE':'BUCK & HICKMAN',
    'BULGIN COMPONENTS':'BULGIN',
    'BULGIN POWER':'BULGIN',
    'BUNENBERG':'BUDENBERG',
    'BURNETT HILLMAN':'BURNETT & HILLMAN',
    'BURNSTEIN':'BERNSTEIN',
    'BUSCH JAEGER - ABB':'BUSCH JAEGER',
    'CABLECRAFT':'CABLE CRAFT',
    'CALDA MORELY':'CALDA-MORLEY',
    'CAMFILUK':'CAMFIL',
    'CANON OFFICE TRADE PRODUCTS':'CANON',
    'CARDWELL':'CALDWELLS',
    'CARLO CAVAZZI':'CARLO GAVAZZI',
    'CARLO GAVAZI':'CARLO GAVAZZI',
    'CARLO GAVEZZI':'CARLO GAVAZZI',
    'CASIO COMPUTER':'CASIO',
    'CATPUMPS':'CAT PUMPS',
    'CENTURIAN':'CENTURION',
    'CENTURION COOLCAP':'CENTURION',
    'CENTURION SAFETY':'CENTURION',
    'CENTURY COMMERCIAL LIGHTING':'CENTURY LIGHTING',
    'CHALLANGE':'CHALLENGE',
    'CHALLENGE POWER TRANSMISSION':'CHALLENGE',
    'CHALLENGER':'CHALLENGE',
    'CHALLLENGE':'CHALLENGE',
    'CHAUVIN ARNOUX ENERGY':'CHAUVIN ARNOUX',
    'CHERRY ELECTRICAL':'CHERRY',
    'CHERRY ELECTRICAL PRODUCTS':'CHERRY',
    'CHESTERON':'CHESTERTON',
    'CHIN NAN PRECISION ELECTRONICS':'CHIN NAN',
    'CK DRAWRING':'CK',
    'CK INDUSTRIAL ENGINEERS':'CK',
    'CK TOOLS (CARL KAMMERLING INTERNATIONAL)':'CK TOOLS',
    'CML INNOVATIVE TECHNOLOGIES':'CML',
    'CONDOR POWER SUPPLIES':'CONDOR',
    'CONDOR USA':'CONDOR',
    'CONTA CLIP':'CONTACLIP',
    'CONTA-CLIP':'CONTACLIP',
    'CONTEINEX':'CONTRINEX',
    'CONTI':'CONTITECH',
    'CONTIECH':'CONTITECH',
    'CONTITCH':'CONTITECH',
    'CONTITEC':'CONTITECH',
    'CONTITEC H':'CONTITECH',
    'CONTITECH POWER TRANSMISSIONS':'CONTITECH',
    'CONTITECHH':'CONTITECH',
    'CONTREX':'CONTRINEX',
    'CONTROL TECHNIQUE':'CONTROL TECHNIQUES',
    'CONTROL TECHNIQUES DRIVES UK L':'CONTROL TECHNIQUES',
    'CONTTECH':'CONTITECH',
    'CONUCTIX':'CONDUCTIX',
    'CONVEYOR NETWRKS':'CONVEYOR NETWORKS',
    'CONVEYOR NTWRKS':'CONVEYOR NETWORKS',
    'COOPER BEARING':'COOPER',
    'COOPER BUSMANN':'COOPER',
    'COOPER BUSSMANN':'COOPER',
    'COOPER BUSSMANN ELX':'COOPER',
    'COOPER CROUSE-HINDS':'COOPER',
    'COOPER FULLEON':'COOPER',
    'COOPER INDUSTS':'COOPER',
    'COOPER LIGHTING':'COOPER',
    'COOPER LIGHTING & SECURITY':'COOPER',
    'COOPER POWER TOOLS':'COOPER',
    'COOPER ROLLER BEARING':'COOPER',
    'COOPER ROLLER BEARINGS':'COOPER',
    'COOPER TOOLS':'COOPER',
    'COOPERS':'COOPER',
    'COPAL ELECTRONICS':'COPAL',
    'CRAIG & DERICOTT':'CRAIG & DERRICOTT',
    'CRAIG AND DERRICOTT':'CRAIG & DERRICOTT',
    'CRAIG DERRICOTT':'CRAIG & DERRICOTT',
    'CRANE FLUID':'CRANE',
    'CRC INDUSTRIES':'CRC',
    'CREE INC':'CREE',
    'CROMWEL':'CROMWELL',
    'CROMWELL CARDIFF':'CROMWELL',
    'CROMWELL TOOLS':'CROMWELL',
    'CROMWELLS':'CROMWELL',
    'CROSE & MORSE':'CROSS & MORSE',
    'CROSS & MOORE':'CROSS & MORSE',
    'CROSS & MORSE ONLY':'CROSS & MORSE',
    'CROSS MORSE':'CROSS & MORSE',
    'CST - CROUZET':'CROUZET',
    'CTS COMPONENTS TAIWAN':'CTS',
    'CULTER HAMMER':'CUTLER HAMMER',
    'CUTLER':'CUTLER HAMMER',
    'CUTLER & HAMMER':'CUTLER HAMMER',
    'CUTLER HAMMER EATON':'CUTLER HAMMER',
    'CUTTING EGDE':'CUTTING EDGE',
    'CUTTLER HAMMER':'CUTLER HAMMER',
    'DADTALOGIC':'DATALOGIC',
    'DAILYWELL ELECTRONICS CO., LTD.':'DAILYWELL',
    'DAIRY PIPELINES':'DAIRY PIPE LINES',
    'DANFOS':'DANFOSS',
    'DANFOSS DRIVES':'DANFOSS',
    'DARASENSOR':'DATASENSOR',
    'DATA LOGIC':'DATALOGIC',
    'DATA SENSOR':'DATASENSOR',
    'DATALOGIC OPTIC ELEC':'DATALOGIC',
    'DATALOGIC PTY':'DATALOGIC',
    'DATALOGIG':'DATALOGIC',
    'DAWID BROWN':'DAVID BROWN',
    'DE VILBISS':'DEVILBISS',
    'DELTA & KIS BESPOKE':'DELTA',
    'DELTA ADHESIVES':'DELTA',
    'DELTA CABLE':'DELTA',
    'DELTA DESIGN':'DELTA',
    'DELTA ELECTRONICS':'DELTA',
    'DELTA ENFIELD':'DELTA',
    'DELTA FLUID':'DELTA',
    'DELTA FLUID PRODUCTS':'DELTA',
    'DELTA LOCK':'DELTA',
    'DELTA MFG':'DELTA',
    'DELTA OHM':'DELTA',
    'DELTA PLUS':'DELTA',
    'DELTA SCHOELLER':'DELTA',
    'DELTA SENSORS':'DELTA',
    'DELTA-C DRILL':'DELTA',
    'DESOUTER':'DESOUTTER',
    'DETALOGIC':'DATALOGIC',
    'DEVELBISS':'DEVILBISS',
    'DEVILBISSS':'DEVILBISS',
    'DEVILLEBISS':'DEVILBISS',
    'DEWALT ENGINEERED BY POWERS':'DEWALT',
    'DEWALT FASTENINGS':'DEWALT',
    'DEWALT POWER TOOLS':'DEWALT',
    'DFRANSFIELDS':'DRANSFIELD',
    'DIALIGHT LUMIDRIVES':'DIALIGHT',
    'DIAMOND CHAIN':'DIAMOND',
    'DIAMOND SAPHIRE':'DIAMOND',
    'DIAMOND SAPPHIRE':'DIAMOND',
    'DICHTAMATICK':'DICHTOMATIK',
    'DICHTOMATI':'DICHTOMATIK',
    'DICHTOMATIC':'DICHTOMATIK',
    'DICHTOMATK':'DICHTOMATIK',
    'DICKSON BEARINGS':'DICKSON',
    'DICTAMATIK':'DICHTOMATIK',
    'DICTOMATIK':'DICHTOMATIK',
    'DIFFENBACHER':'DIEFFENBACHER',
    'DODGE BEARING':'DODGE',
    'DODGE MFG':'DODGE',
    'DONALDSONS':'DONALDSON',
    'DOORMAN SMITH':'DORMAN SMITH',
    'DORMER TOOLS':'DORMER',
    'DORMER TOOLS JAPAN':'DORMER',
    'DRANSFIELDS':'DRANSFIELD',
    'DRAPER EXPERT':'DRAPER',
    'DRAPER TOOL':'DRAPER',
    'DRASFIELD':'DRANSFIELD',
    'DRR ECOCLEAN':'DURR ECOCLEAN',
    'DUNGS COMBUSTION':'DUNGS',
    'DUNLOP DSL':'DUNLOP',
    'DUNLOP HEVE':'DUNLOP',
    'DUNLOP HEVEA':'DUNLOP',
    'DUNLOPE':'DUNLOP',
    'DUPONT ENGINEERING PRODUCTS':'DUPONT',
    'DYMO INDUSTRIAL':'DYMO',
    'DYMO XTL':'DYMO',
    'DYNABLADE':'DYNABRADE',
    'EATON AEROQUIP':'EATON',
    'EATON BUSSMANN':'EATON',
    'EATON ELECTRICAL PRODUCTS LTD - BUSS':'EATON',
    'EATON HANSEN':'EATON',
    'EATON HYDRAULICS':'EATON',
    'EATON KEMPSTON CONTROLS':'EATON',
    'EATON SYNFLEX':'EATON',
    'EATON VICKERS':'EATON',
    'EATON WEATHERHEAD':'EATON',
    'EATON WILLIAMS':'EATON',
    'EBM PAPST':'EBM-PAPST',
    'EBMPABST':'EBM-PAPST',
    'EBMPAPST':'EBM-PAPST',
    'EBMPAPTST':'EBM-PAPST',
    'ECLIPSE BLUE':'ECLIPSE',
    'ECLIPSE MAGNETICS':'ECLIPSE',
    'ECLIPSE TOOLS':'ECLIPSE',
    'EDMPAPST':'EBM-PAPST',
    'EMBPAPST':'EBM-PAPST',
    'EMERSO':'EMERSON',
    'EMERSON MFG':'EMERSON',
    'EMERSON NETWORK':'EMERSON',
    'EMERSON PROCESS':'EMERSON',
    'EMERSON PROCESS MANAGEMEN':'EMERSON',
    'ENDRESS & HAUSE':'ENDRESS & HAUSER',
    'ENDRESS HAUSER':'ENDRESS & HAUSER',
    'ENERGISER':'ENERGIZER',
    'ENTRELEC MTE':'ENTRELEC',
    'EPH EDMUNDSEN':'EPH EDMUNDSON',
    'EPSON TOYOCOM':'EPSON',
    'EREM BY WELLER':'EREM',
    'ERIKS BAYERN':'ERIKS',
    'ERIKS GASKET':'ERIKS',
    'ERIKS GROUP NV':'ERIKS',
    'ERIKS IND SVCS':'ERIKS',
    'ERIKS OWN':'ERIKS',
    'ERIKS RX':'ERIKS',
    'ERIKS U':'ERIKS',
    'ERWIN SICK':'SICK',
    'ESSELTE DYMO':'ESSELTE',
    'EUROPA COMPONENTS':'EUROPA',
    'EUROPA COMPONENTS & EQUIPMENT':'EUROPA',
    'EUROPA TOOL COMPAN':'EUROPA',
    'EUROTHERM CONTROLS':'EUROTHERM',
    'EUROTHERM DRIVES':'EUROTHERM',
    'EUROTHERM RECORDERS':'EUROTHERM',
    'EUROTHREM':'EUROTHERM',
    'EXPERT BRITOL':'EXPERT',
    'EXPERT BY FACOM':'FACOM',
    'EXPERT CABLES':'EXPERT',
    'EXPERT SITE ASSIST':'EXPERT',
    'EXPERT TUNKERS':'EXPERT',
    'EXPERT-TNKERS':'EXPERT',
    'EXPERT-TUENKERS':'EXPERT',
    'EXPERT-TUNKERS':'EXPERT',
    'FAG BEARINGS':'FAG',
    'FAG KUGELFISCHER AG':'FAG',
    'FAGOR ELECTRONICA':'FAGOR',
    'FAIRCHILE':'FAIRCHILD',
    'FAITHFULL':'FAITHFUL',
    'FCI CONNECTORS':'FCI',
    'FCT - A MOLEX':'FCT',
    'FEIN SAS':'FEIN',
    'FELLOWES JAPAN KK':'FELLOWES',
    'FENNER CRE':'FENNER',
    'FENNER DRIVES':'FENNER',
    'FENNER ELECTRONIC CONTROL':'FENNER',
    'FENNER POWER PLUS':'FENNER',
    'FENNERCONTITECH':'FENNER',
    'FENNERDRIVES':'FENNER',
    'FEST0':'FESTO',
    'FESTO A':'FESTO',
    'FISCHER CONNECTORS':'FISCHER',
    'FISCHER ELEKTRONIK':'FISCHER',
    'FISCHER FIXINGS':'FISCHER',
    'FK BEARINGS':'FS BEARINGS',
    'FLEXIBLE CONNECTIOINS':'FLEXIBLE CONNECTIONS',
    'FLEXIBLE CONNECTIONS MIDDLEWIC':'FLEXIBLE CONNECTIONS',
    'FLOTRONICS':'FLOTRONIC',
    'FLOW SERVE':'FLOWSERVE',
    'FLOWTECHNOLOGYUK':'FLOWTECHNOLOGY',
    'FLOW-TRONIC':'FLOTRONIC',
    'FLOWTRONICS':'FLOTRONIC',
    'FLUKE (UK)':'FLUKE',
    'FLUKE BIOMEDICAL':'FLUKE',
    'FLUKE NETWORKS':'FLUKE',
    'FLURO-GELENKLAGER':'FLURO',
    'FORBO SEIGLIN':'FORBO SIEGLING',
    'FORBO SEIGLING':'FORBO SIEGLING',
    'FORBO-SIEGLING':'FORBO SIEGLING',
    'FOXCONN INTERCONNECT TECHNOLOGY (FIT)':'FOXCONN',
    'FPTOOLS':'FP TOOLS',
    'FREESCALE SEMICONDUCTOR JAPAN':'FREESCALE',
    'FREUDENBERG SEALING TECHNOLOGIES SIMRIT':'FREUDENBERG SEALING TECHNOLOGIES',
    'FREUDENBURG':'FREUDENBERG',
    'FREUNDENBERG':'FREUDENBERG',
    'FROEHLICH':'JW FROEHLICH',
    'FSB BEARINGS':'FS BEARINGS',
    'FUJI ELECTRIC':'FUJI',
    'FUJI LATEX':'FUJI',
    'FUJI PHOTO FILM':'FUJI',
    'FUJI XEROX':'FUJI',
    'FUJIAN NANPING NANFU BATTERY COLTD':'FUJI',
    'FUJIFILM':'FUJI',
    'FUJII':'FUJI',
    'FUJITSU COMPONENT':'FUJITSU',
    'FUJIYA COLTD':'FUJIYA',
    'FUSION LAMPS':'FUSION',
    'GARRYSON INSLEY':'GARRYSON',
    'GATE':'GATES',
    'GATES EMB':'GATES',
    'GATES ENERGY PRODS':'GATES',
    'GATES POWER TRANSMISSION':'GATES',
    'GATES PT':'GATES',
    'GATESMEGADYNE':'GATES',
    'GATESSYNCHROPOWER':'GATES',
    'GAURD MASTER':'GUARDMASTER',
    'GAURDMASTER':'GUARDMASTER',
    'GE CRITICAL POWER':'GE',
    'GE LIGHTING':'GE',
    'GE POWER CONTROLS':'GE',
    'GEA WESTFALIA':'GEA',
    'GEA WESTFALILA':'GEA',
    'GEAR WRENCH':'GEARWRENCH',
    'GEC ALSTOM':'GEC ALSTHOM',
    'GEDORE TORQUELEADER':'GEDORE',
    'GEMINI DATA LOGGERS':'GEMINI',
    'GENERAL ELECTRONICS':'GE',
    'GENERIC':'UNBRANDED',
    'GEORGE FISCHER':'GEORG FISCHER',
    'GEORGIA PACIFIC':'GEORGIA-PACIFIC',
    'GERBER LEGENDARY BLADES':'GERBER',
    'GG BEARING':'GGB BEARING',
    'GGB BEARINGS':'GGB BEARING',
    'GLACIER - SOURCE CFC':'GLACIER',
    'GLACIER GARLOCK BEARING':'GLACIER',
    'GLACIER GARLOCK BEARINGS':'GLACIER',
    'GLACIER METAL':'GLACIER',
    'GLACIER VAN DER VELL':'GLACIER',
    'GLACIERIHG':'GLACIER',
    'GLENAIRWYKO':'GLENAIR',
    'GLOBAL LASER TECHNOLOGY SOLUTI':'GLOBAL LASER',
    'GOLIATH THREADING':'GOLIATH',
    'GONINGER':'GRONINGER',
    'GOODYEAR TIRE':'GOODYEAR',
    'GOODYEARFERODO':'GOODYEAR',
    'GRAND-TEK TECHNOLOGY':'GRAND-TEK',
    'GRASELLI':'GRASSELLI',
    'GREEN BROOK':'GREENBROOK',
    'GREENBRROK':'GREENBROOK',
    'GREENLEE COMMUNICATIONS':'GREENLEE',
    'GREENLEE TEMPO':'GREENLEE',
    'GREENLEE TEXTRON':'GREENLEE',
    'GRONINGA':'GRONINGER',
    'GRUNDFOS UK':'GRUNDFOS',
    'GRUNDFOSUK':'GRUNDFOS',
    'GUARD MASTER':'GUARDMASTER',
    'HABASI':'HABASIT',
    'HABASIT AMERICA':'HABASIT',
    'HABASIT BELTING':'HABASIT',
    'HABASIT ROSSI':'HABASIT',
    'HABASITT':'HABASIT',
    'HAGER KLIK':'HAGER',
    'HAGER POWERTECH':'HAGER',
    'HAKKO/CHP':'HAKKO',
    'HAMAMATSU PHOTONICS':'HAMAMATSU',
    'HAMAMATSU TOA ELECTRONICS':'HAMAMATSU',
    'HAMMOND MANUFACTURING':'HAMMOND',
    'HANDMANN':'HANDTMANN',
    'HANDTMAN':'HANDTMANN',
    'HATTESLEY':'HATTERSLEY',
    'HAYLEY 247':'HAYLEY',
    'HAYLEY BEARINGS':'HAYLEY',
    'HAYLEY NORTH EAST':'HAYLEY',
    'HAYLEY WOLVERHAMPTON':'HAYLEY',
    'HAYSSEN SANDIACRE':'HAYSSENSANDIACRE',
    'HEDELBERG':'HEIDELBERG',
    'HEDENHEIN':'HEIDENHAIN',
    'HEGSTLER':'HENGSTLER',
    'HEIDELBRG':'HEIDELBERG',
    'HEIDELBURG':'HEIDELBERG',
    'HEIDENHAIM':'HEIDENHAIN',
    'HEIDENHAN':'HEIDENHAIN',
    'HEIDERHAIN':'HEIDENHAIN',
    'HEILDELBERG':'HEIDELBERG',
    'HELLER':'HELLERMANNTYTON',
    'HELLERMAN':'HELLERMANNTYTON',
    'HELLERMAN TYTON':'HELLERMANNTYTON',
    'HELLERMANN':'HELLERMANNTYTON',
    'HELLERMANN INSULOID':'HELLERMANNTYTON',
    'HELLERMANN TYTON':'HELLERMANNTYTON',
    'HELLERMANN TYTON BHD':'HELLERMANNTYTON',
    'HELLERMANN TYTON DATA':'HELLERMANNTYTON',
    'HENKEL LOCTITE ADHESIVES':'LOCTITE',
    'HEPCO MOTION':'HEPCO',
    'HEPCO SLIDE':'HEPCO',
    'HERSCHMANN':'HIRSCHMANN',
    'HEWLETT PACKARD (HP)':'HEWLETT PACKARD',
    'HIEDELBERG':'HEIDELBERG',
    'HIOKI EE':'HIOKI',
    'HIROSE ELECTRIC':'HIROSE',
    'HIRSCHMAN':'HIRSCHMANN',
    'HIRSCHMANN TEST & MEASUREMENT':'HIRSCHMANN',
    'HITACHI CABLE':'HITACHI',
    'HITACHI MAXELL':'HITACHI',
    'HITACHI POWER TOOLS':'HITACHI',
    'HITACHI SEMICONDUCTOR':'HITACHI',
    'HOEABIGER':'HOERBIGER',
    'HOERDIGER':'HOERBIGER',
    'HOFFMAN':'HOFFMANN',
    'HOFFMAN COOLING':'HOFFMANN',
    'HOFFMAN ENCLOSURES':'HOFFMANN',
    'HONEYWELL ANALYTICS':'HONEYWELL',
    'HONEYWELL BURDICK & JACKSON':'HONEYWELL',
    'HONEYWELL CONTROL SYSTEMS':'HONEYWELL',
    'HONEYWELL FEND-ALL':'HONEYWELL',
    'HONEYWELL FIBRE-METAL':'HONEYWELL',
    'HONEYWELL HOWARD LEIGHT':'HONEYWELL',
    'HONEYWELL INTERNATIONAL':'HONEYWELL',
    'HONEYWELL MILLER':'HONEYWELL',
    'HONEYWELL NORTH':'HONEYWELL',
    'HONEYWELL SERVUS':'HONEYWELL',
    'HONEYWELL UVEX':'HONEYWELL',
    'HONWEYWELL':'HONEYWELL',
    'HONYWELL':'HONEYWELL',
    'HOPKINSONS':'HOPKINSON',
    'HUNTITECH':'CONTITECH',
    'HYDRAMTICS':'HYDRAMATICS',
    'HYDROMATICS':'HYDRAMATICS',
    'IDEC PTY':'IDEC',
    'IFM EFECTOR':'IFM',
    'IFM ELECTRONIC':'IFM',
    'IFM ELECTRONICS':'IFM',
    'IKO NIPPON THOMPSON':'IKO',
    'IMI NORGREN':'NORGREN',
    'INAFAG':'INA',
    'INA-SCHAEFFLER':'INA',
    'INA-SCHAEFFLER KG':'INA',
    'INGERSOL RAND':'INGERSOLL RAND',
    'INGERSOLL RAND (CMS WYKO)':'INGERSOLL RAND',
    'INGERSOLL-RAND':'INGERSOLL RAND',
    'INSTRUMENTS DIRECT(SERVICES)':'INSTRUMENTS DIRECT',
    'INTEGRAL MEMORY':'INTEGRAL',
    'INTER FOOD':'INTERFOOD',
    'INTERFOOD SLICING':'INTERFOOD',
    'INTERFOOD TECHNOLOG':'INTERFOOD',
    'INTERFOOD TECHNOLOGY LT':'INTERFOOD',
    'INTERFOODS':'INTERFOOD',
    'INTEROL':'INTERROLL',
    'INTEROLL':'INTERROLL',
    'INTERROL':'INTERROLL',
    'INTERROLLER':'INTERROLL',
    'IRWIN HANSON':'IRWIN',
    'IRWIN INDUSTRIAL TOOL':'IRWIN',
    'IRWIN MARPLES':'IRWIN',
    'IRWIN VISE-GRIP':'IRWIN',
    'ISOCOM COMPONENTS':'ISOCOM',
    'ITT CANNON':'ITT',
    'ITT COMPOSANTS':'ITT',
    'ITT INDUSTRIES CANNON':'ITT',
    'ITT INSTRUMENTS':'ITT',
    'ITT SEALECTRO':'ITT',
    'ITW ALMA':'ITW',
    'ITW BEE LEITZKE':'ITW',
    'ITW CONSTRUCTION PRODUCTS':'ITW',
    'ITW DEVCON':'ITW',
    'ITW DYMON':'ITW',
    'ITW PANCON':'ITW',
    'ITW PRODUITS CHIMIQUES':'ITW',
    'ITW SPIT':'ITW',
    'ITW SWITCHES':'ITW',
    'J A HARRISONS':'JA HARRISON',
    'J W FROEHLICH':'JW FROEHLICH',
    'JA HARISON':'JA HARRISON',
    'JACKCON CAPACITOR ELECTRONICS CO':'JACKCON CAPACITOR',
    'JAE ELECTRONICS':'JAE',
    'JAE HAKKO':'JAE',
    'JAEGER CONNECTEURS':'JAEGER',
    'JAMES WALKERAMTEC':'JAMES WALKER',
    'JAPAN AVIATION ELECTRONICS':'JAPAN AVIATION',
    'JARVIS B WEBB':'JERVIS B WEBB',
    'JERVIS BE WEBB':'JERVIS B WEBB',
    'JERVIS WEBB':'JERVIS B WEBB',
    'JERVISBWEBB':'JERVIS B WEBB',
    'JOUOUMATIC':'JOUCOMATIC',
    'JSCHNEIDER':'SCHNEIDER',
    'JST MANUFACTURING':'JST',
    'JUCOMATIC':'JOUCOMATIC',
    'JW FREOHLICH':'JW FROEHLICH',
    'JW FROELICH':'JW FROEHLICH',
    'JWFROEHLICH':'JW FROEHLICH',
    'KA SCHMERSAL':'SCHMERSAL',
    'KAI SUH SUH ENTERPRISES':'KAI SUH SUH',
    'KAYSON GREE':'KAYSON GREEN',
    'KEMET ELECTRONICS':'KEMET',
    'KENNEDY PROFESSIONAL':'KENNEDY',
    'KENNEDY-CROMWELL':'KENNEDY',
    'KEY STONE CASTORS':'KEYSTONE CASTORS',
    'KEYSIGHT TECHNOLOGIES':'KEYSIGHT',
    'KEYSTON VALVES':'KEYSTONE VALVES',
    'KEYSTONE CASTOR':'KEYSTONE CASTORS',
    'KIMBERLY CLARK PROFESSIONAL':'KIMBERLY CLARK',
    'KINGSPOR':'KLINGSPOR',
    'KLAXON SIGNALS':'KLAXON',
    'KLCOKNER MOELLER':'KLOCKNER MOELLER',
    'KLINGERSIL C-4401 CUT GASKETS':'KLINGERSIL',
    'KLINGPSOR':'KLINGSPOR',
    'KLOCKNER':'KLOCKNER MOELLER',
    'KNIPEX-WERK':'KNIPEX',
    'KOBOLD INSTRS':'KOBOLD',
    'KONE CRANES':'KONECRANES',
    'KONECRANE':'KONECRANES',
    'KOPEX INTERNATIONAL':'KOPEX',
    'KOYO BEARINGS':'KOYO',
    'KOYO BEARINGS DEUTSCHLAND':'KOYO',
    'KOYO INTL':'KOYO',
    'KOYOTORRINGTON FAFNIR':'KOYO',
    'KRAM SCHRODER':'KROMSCHRODER',
    'KRAUS NAIMER':'KRAUS & NAIMER',
    'KROM SCHRODER':'KROMSCHRODER',
    'KROM SCHROEDER':'KROMSCHRODER',
    'KROMSCHODER':'KROMSCHRODER',
    'KROMSHCROEDER':'KROMSCHRODER',
    'KRONECRANES':'KONECRANES',
    'KRONES AG':'KRONES',
    'KRUAS & NAIMER':'KRAUS & NAIMER',
    'KYOCERA SGS PRECISION TOOLS':'KYOCERA',
    'KYORITSU ELECTRICAL':'KYORITSU',
    'KYORITSU SHUPPAN':'KYORITSU',
    'LANDIS GYR':'LANDIS & GYR',
    'LAPP CABLE':'LAPP',
    'LAPP-KABEL':'LAPP',
    'LASCAR ELECTRONICS':'LASCAR',
    'LAWSON FUSES':'LAWSON',
    'LAWSONMA':'LAWSON',
    'LEE SPRINGS':'LEE SPRING',
    'LEESPRING':'LEE SPRING',
    'LEM INDUSTRIES':'LEM',
    'LEROY SOMERS':'LEROY SOMER',
    'LEROYSOMER':'LEROY SOMER',
    'LEROY-SOMER':'LEROY SOMER',
    'LEUZE MAYSER':'LEUZE',
    'LEUZE MAYSER ELECTRONIC':'LEUZE',
    'LINEAR BUSHING':'LINEAR',
    'LITTELFUSE - ON SEMI':'LITTELFUSE',
    'LITTELFUSE - RAYCHEM':'RAYCHEM',
    'LITTELFUSE JAPAN':'LITTELFUSE',
    'LITTLE FUSE':'LITTELFUSE',
    'LITTLEFUSE':'LITTELFUSE',
    'LLEN BRADLEY':'ALLEN BRADLEY',
    'LOVATO UK LTD':'LOVATO',
    'LOWE & FLETCHE':'LOWE & FLETCHER',
    'LOWE FLETCHER':'LOWE & FLETCHER',
    'LUBETECH INDUSTRIES':'LUBETECH',
    'LUBETECH NPS UK':'LUBETECH',
    'LUBETECHNPSUK':'LUBETECH',
    'LUMBERG AUTOMATION':'LUMBERG',
    'LUTRON ELECTRONIC ENT':'LUTRON',
    'MAC VALVE':'MAC VALVES',
    'MAISTER ABRASIVES':'MASTER ABRASIVES',
    'MAKITA ELECTRIC':'MAKITA',
    'MAKITA POWER TOOLS':'MAKITA',
    'MAKITA SPA':'MAKITA',
    'MANROLAND':'MAN ROLAND',
    'MARCHESIN':'MARCHESINI',
    'MARELLIMOTOR':'MARELLI MOTORI',
    'MARELLIMOTORI':'MARELLI MOTORI',
    'MARKEM IMAJE':'MARKEM',
    'MARKEM-IMAJE':'MARKEM',
    'MARTIN CONTIMACH':'MARTIN',
    'MARTIN GLASS':'MARTIN',
    'MARTIN LUNEL':'MARTIN',
    'MARTIN SPROCKET':'MARTIN',
    'MARTIN STACKER':'MARTIN',
    'MARTINBOBST':'MARTIN',
    'MARTINBSL':'MARTIN',
    'MARTINDALE ELECTRIC':'MARTINDALE',
    'MARTING':'MARTIN',
    'MASETRABRASIVES':'MASTER ABRASIVES',
    'MATSUSHITA ELECTRIC INDUSTRIAL':'MATSUSHITA',
    'MAXIM INTEGRATED PRODUCT':'MAXIM INTEGRATED',
    'MAXIM INTEGRATED PRODUCTS':'MAXIM INTEGRATED',
    'MAYR CORP':'MAYR',
    'MAYR GMBH':'MAYR',
    'MAYR ROBA -RUTSCHNABE':'MAYR',
    'MCGILL BEARINGS':'MCGILL',
    'MCGILL CAGEROL':'MCGILL',
    'MCGILL INDUST':'MCGILL',
    'MCGILL MCG TRACK ROLLER - CAM':'MCGILL',
    'MCGILL MFG':'MCGILL',
    'MCGILL PRECISION BEARINGS':'MCGILL',
    'MCGILL UK':'MCGILL',
    'MDM PUMP':'MDM PUMPS',
    'MEANWELL':'MEAN WELL',
    'MEDWAY ENGLAND':'MEDWAY',
    'MEDWAY POWER TRANSMISSION':'MEDWAY',
    'MEDWAY POWER TRANSMISSIONS':'MEDWAY',
    'MEDWAY-DUNLOP':'MEDWAY',
    'MEDWAY-MEGADYNE':'MEDWAY',
    'MEGA':'MEGADYNE',
    'MEGADIN':'MEGADYNE',
    'MEGADTNE':'MEGADYNE',
    'MEGADYME':'MEGADYNE',
    'MEGADYNE CZ':'MEGADYNE',
    'MEGADYNE MEDICAL PRODT':'MEGADYNE',
    'MEGADYNE ULMA':'MEGADYNE',
    'MEGADYNEREISER':'MEGADYNE',
    'MEISTER ABRASIVES':'MASTER ABRASIVES',
    'MENN':'MENNEKES',
    'MENNEKES ELECTROTECHNIK':'MENNEKES',
    'MENNK':'MENNEKES',
    'MENNKENES':'MENNEKES',
    'MENNKES':'MENNEKES',
    'MERLIN':'MERLIN GERIN',
    'MERLIN GARIN':'MERLIN GERIN',
    'MERLING GERIN':'MERLIN GERIN',
    'MERSEN/FERRAZ SHAWMUT':'MERSEN',
    'MERSEY FLEX':'MERSEYFLEX',
    'METALFEX':'METALFLEX',
    'METALWORK PNEUMATIC':'METAL WORK',
    'METRIX ELECTRONICS':'METRIX',
    'METTLER-TOLEDO':'METTLER TOLEDO',
    'MICREL INC':'MICREL',
    'MICROCHIP TECHNOLOGY':'MICROCHIP',
    'MIDLAND ABRASIVES':'MIDLAND',
    'MIDLAND FLUID':'MIDLAND',
    'MIDLAND INDUSTRIAL DESIGN':'MIDLAND',
    'MIDLAND JAY':'MIDLAND',
    'MIDLAND OSRAM':'MIDLAND',
    'MIDLAND PNEUMATICS':'MIDLAND',
    'MIDLAND POWER & MOTION':'MIDLAND',
    'MIDLAND ROSS':'MIDLAND',
    'MILWAUKEE VALVE':'MILWAUKEE',
    'MISUMI EUROPA':'MISUMI',
    'MISUMIMFG':'MISUMI',
    'MITISBUISHI':'MITSUBISHI',
    'MITSIBISHI':'MITSUBISHI',
    'MITSIBUSHI':'MITSUBISHI',
    'MITSUBISH':'MITSUBISHI',
    'MITSUBISHI CHEMICAL':'MITSUBISHI',
    'MITSUBISHI ELECTRIC':'MITSUBISHI',
    'MITSUBISHI MATERIALS':'MITSUBISHI',
    'MITSUBISHI PLC':'MITSUBISHI',
    'MITSUBOSHI':'MITSUBISHI',
    'MITSUBOTSHI':'MITSUBISHI',
    'MITSUBSHI':'MITSUBISHI',
    'MITSUBUSHI':'MITSUBISHI',
    'MK HONEYWELL':'HONEYWELL',
    'MOELLER ELECTRIC':'MOELLER',
    'MOFLASH SIGNALLING':'MOFLASH',
    'MOLEX ELECTRONICS':'MOLEX',
    'MOLEX PREMISE':'MOLEX',
    'MOLEX PREMISE NETWORKS':'MOLEX',
    'MONDINI':'G MONDINI',
    'MONO PUMP':'MONO PUMPS',
    'MONO PUMPS LTD (401500)':'MONO PUMPS',
    'MONOPUMP':'MONO PUMPS',
    'MONOPUMPS':'MONO PUMPS',
    'MONTSELAS':'MONT SELAS',
    'MORESECURE STORAGE':'MORESECURE',
    'MORTONAIR':'MARTONAIR',
    'MOSSEXPRESS':'MOSS EXPRESS',
    'MOTORVARIO':'MOTOVARIO',
    'MSA MANUFACTURING':'MSA',
    'MUELLER ELECTRIC':'MUELLER',
    'MUELLER STEAM SPECIALTY':'MUELLER',
    'MULTICONTACT':'MULTI CONTACT',
    'MULTI-CONTACT':'MULTI CONTACT',
    'MULTIVA':'MULTIVAC',
    'MULTIVACMEGADYNE':'MULTIVAC',
    'MURATA POWER SOLUTIONS':'MURATA',
    'MURR':'MURRELEKTRONIK',
    'MURR ELECTRONIK':'MURRELEKTRONIK',
    'MURR ELEKTRONIC':'MURRELEKTRONIK',
    'MURRELECTRONIC':'MURRELEKTRONIK',
    'MURRELEKTRONIC':'MURRELEKTRONIK',
    'MURRELEKTRONIK LIMITED':'MURRELEKTRONIK',
    'MURRELEKTRONIL':'MURRELEKTRONIK',
    'MURTONAIR':'MARTONAIR',
    'NEC ENGINEEARINGLTD':'NEC',
    'NEC TOKIN':'NEC',
    'NEUMATICS':'PNEUMATIC',
    'NEUTRA':'NEUTRAL',
    'NEW & EYRE':'NEWEY & EYRE',
    'NEW JAPAN RADIO':'NEW JAPAN RADIA',
    'NEWEY':'NEWEY & EYRE',
    'NEWEY & AYRE':'NEWEY & EYRE',
    'NEWEY & EYR':'NEWEY & EYRE',
    'NEWEY EYRE':'NEWEY & EYRE',
    'NEXANS BELGIUM':'NEXANS',
    'NEXANS DRAVEIL':'NEXANS',
    'NIC COMPONENTS':'NIC',
    'NIC INSTRUMENTS':'NIC',
    'NIPPON BEARING':'NIPPON',
    'NIPPON BEARINGS (KBS)':'NIPPON',
    'NIPPON CHEMI-CON':'NIPPON',
    'NIPPON JITSUGYO PUBLISHING':'NIPPON',
    'NIPPON SEISEN CABLE':'NIPPON',
    'NISSEI ELECTRIC':'NISSEI',
    'NISSEI ELECTRIC CO. LTD':'NISSEI',
    'NISSEI SANGYO':'NISSEI',
    'NKK SWITCHES':'NKK',
    'NOGA JAPAN':'NOGA',
    'NON-BRANDED':'Unbranded',
    'NORBAR TORQUE':'NORBAR',
    'NORBAR TORQUE TOOL':'NORBAR',
    'NORGRENRS COMPONENTS':'NORGREN',
    'NORTON ABRASIVES':'NORTON',
    'NORTON SAFETY PRODUCTS':'NORTON',
    'NORTONICS FOXTAM':'NORTONICS',
    'NORTOOLS INTERNATIONAL LTD':'NORTOOLS',
    'NS TOOLS (CO.LTD)':'NS TOOLS',
    'NSK LTD':'NSK',
    'NSK-LTD':'NSK',
    'NTN BEARINGS':'NTN',
    'NUMATIC':'NUMATICS',
    'NURRELEKTRONIK':'MURRELEKTRONIK',
    'NU-TECH ENGINEERING':'NU-TECH',
    'NUTOOL MACHINERY':'NUTOOL',
    'NUVOTEM TALEMA':'NUVOTEM',
    'NVENT – HOFFMAN':'NVENT',
    'NVENT – RAYCHEM':'NVENT',
    'NVENT – SCHROFF':'NVENT',
    'NVENT CADDY':'NVENT',
    'NVENT SCHROFF':'NVENT',
    'OILITE BEARINGS':'OILITE',
    'OILITEBSL':'OILITE',
    'OKW ENCLOSURES':'OKW',
    'OMRO':'OMRON',
    'OMROM':'OMRON',
    'OMRON ELECTRONIC COMPONENTS':'OMRON',
    'OMRON ELECTRONICS':'OMRON',
    'OMRON STI':'OMRON',
    'OPTI':'OPTIBELT',
    'OPTI BELT':'OPTIBELT',
    'OPTIALPHA':'OPTIBELT',
    'OPTIBEL':'OPTIBELT',
    'OPTIBELT (UK) LIMITED':'OPTIBELT',
    'OPTIBELT 8MA':'OPTIBELT',
    'OPTIBELT ALPHA':'OPTIBELT',
    'OPTIBELT ALPHA POWER':'OPTIBELT',
    'OPTIBELT CORP':'OPTIBELT',
    'OPTIBELT FRANCE':'OPTIBELT',
    'OPTIBELT GMBH':'OPTIBELT',
    'OPTIBELT OMEGA':'OPTIBELT',
    'OPTIBELT RB':'OPTIBELT',
    'OPTIBELT UK':'OPTIBELT',
    'OPTIBELT VB':'OPTIBELT',
    'AB ELEKTRONIC':'AB ELECTRONIK',
    'ANTECH ENG':'ANTECH ENGINEERING',
    'ARIES':'ARIES PACKAGING',
    'BESTPUMP':'BEST PUMPS',
    'BIEJIER ELECTRONICS':'BEIJER',
    'BROOK':'BROOK CROMPTON',
    'BSS (UK)':'BSS',
    'BUSSMAN':'BUSSMANN',
    'BUSSMANN':'EATON',
    'COOPER BUSSMAN':'COOPER',
    'CRANES':'CRANE',
    'CSI INDUSTRIES':'CSI',
    'DENCO LUBRICATION':'DENCO',
    'DODD GROUP':'DODD',
    'DODDS':'DODD',
    'EDMUNDSON ELELCTRICAL':'EDMUNDSON',
    'ELMORE ROBOT':'ELMORE',
    'FLEXLINK CONVEYORS':'FLEXLINK',
    'FLEXRITE CHEMGIENE':'FLEXRITE',
    'GEA FOOD SOLUTIONS':'GEA',
    'GEA PROCESS ENGINEERING':'GEA',
    'GEA TUCHENHAGEN':'GEA',
    'K B S':'KSB',
    'K B S PUMPS':'KSB',
    'KECOLPU':'KECOL',
    'KLUBER LUBRICATION':'KLUBER',
    'LAN HANDLING SYSTEMS':'LAN HANDLING',
    'LOGOPAK INTERNATIONAL':'LOGOPAK',
    'METAL WORK ITALIA':'METAL WORK',
    'METALWORK':'METAL WORK',
    'MURRELECTRONIK':'MURRELEKTRONIK',
    'NOGREN':'NORGREN',
    'PARKER HANNIFIN':'PARKER',
    'PARKER RECTUS TEMA':'PARKER',
    'PEPPERL + FUCHS':'PEPPERL+FUCHS',
    'PEPPRL & FUCHS':'PEPPERL+FUCHS',
    'PHOENIX CONTACT':'PHOENIX',
    'POLAR SYSTEMS':'POLAR',
    'ROCKWELL AUTOMATION':'ROCKWELL',
    'RS COMPONENTS':'RS',
    'SAMSON CONTROLS':'SAMSON',
    'SCHNEIDER ELECTRIC':'SCHNEIDER',
    'SELO BOLLANS':'SELO',
    'SEW-EURODRIVE':'SEW',
    'SIGMA GIKEN':'SIGMA',
    'SOMIC SONDERMASCHINENBAU FUER':'SOMIC',
    'SOMIC VERPACKUNGSMASCHINEN':'SOMIC',
    'SPIRAX-SARCO':'SPIRAX SARCO',
    'STANGE ELECTRONICS':'STANGE',
    'SYSTEM PLAST':'SYSTEMPLAST',
    'TE':'TEC',
    'TOYO JIDORI':'TOYO',
    'VEGA CONTROLS':'VEGA',
    'WATSON MARLOW':'WATSON-MARLOW',
    'WEIDMÜLLER':'WEIDMULLER'
}

patterns_prefix = [
    {'pattern':'CLIMAVENETA','brand':'CLIMAVENETA'},
    {'pattern':'ROTABROACH','brand':'ROTABROACH'},
    {'pattern':'SCHIERHOLZ','brand':'SCHIERHOLZ'},
    {'pattern':'SILVERLINE','brand':'SILVERLINE'},
    {'pattern':'SCHNEIDER','brand':'SCHNEIDER'},
    {'pattern':'ULTRATAPE','brand':'ULTRATAPE'},
    {'pattern':'AMBERSIL','brand':'AMBERSIL'},
    {'pattern':'GARRYSON','brand':'GARRYSON'},
    {'pattern':'STARRETT','brand':'STARRETT'},
    {'pattern':'ANDREWS','brand':'ANDREWS'},
    {'pattern':'BRITOOL','brand':'BRITOOL'},
    {'pattern':'DESTACO','brand':'DESTACO'},
    {'pattern':'ECLIPSE','brand':'ECLIPSE'},
    {'pattern':'GERRATT','brand':'GERRATTS'},
    {'pattern':'GUHRING','brand':'GUHRING'},
    {'pattern':'LUMATIC','brand':'LUMATIC'},
    {'pattern':'MERLETT','brand':'MERLETT'},
    {'pattern':'NORDSON','brand':'NORDSON'},
    {'pattern':'PARWELD','brand':'PARWELD'},
    {'pattern':'ROEBUCK','brand':'ROEBUCK'},
    {'pattern':'STANLEY','brand':'STANLEY'},
    {'pattern':'DORMER','brand':'DORMER'},
    {'pattern':'DRAPER','brand':'DRAPER'},
    {'pattern':'GESIPA','brand':'GESIPA'},
    {'pattern':'LEGRIS','brand':'LEGRIS'},
    {'pattern':'LYNDON','brand':'LYNDON'},
    {'pattern':'MAKITA','brand':'MAKITA'},
    {'pattern':'MISUMI','brand':'MISUMI'},
    {'pattern':'NORTON','brand':'NORTON'},
    {'pattern':'OSBORN','brand':'OSBORN'},
    {'pattern':'RULAND','brand':'RULAND'},
    {'pattern':'AVDEL','brand':'AVDEL'},
    {'pattern':'BAHCO','brand':'BAHCO'},
    {'pattern':'BOSCH','brand':'BOSCH'},
    {'pattern':'COMAU','brand':'COMAU'},
    {'pattern':'FESTO','brand':'FESTO'},
    {'pattern':'GRACO','brand':'GRACO'},
    {'pattern':'HYDAC','brand':'HYDAC'},
    {'pattern':'IRWIN','brand':'IRWIN'},
    {'pattern':'MODUS','brand':'MODUS'},
    {'pattern':'MUREX','brand':'MUREX'},
    {'pattern':'PERMA','brand':'PERMA'},
    {'pattern':'ROCOL','brand':'ROCOL'},
    {'pattern':'ABUS','brand':'ABUS'},
    {'pattern':'ASCO','brand':'ASCO'},
    {'pattern':'BURK','brand':'BURKERT'},
    {'pattern':'CEJN','brand':'CEJN'},
    {'pattern':'DANF','brand':'DANFOSS'},
    {'pattern':'IGUS','brand':'IGUS'},
    {'pattern':'MECA','brand':'MECALINE'},
    {'pattern':'NERO','brand':'NERO'},
    {'pattern':'PIAB','brand':'PIAB'},
    {'pattern':'RODO','brand':'RODO'},
    {'pattern':'THOR','brand':'THOR'},
    {'pattern':'WADE','brand':'WADE'},
    {'pattern':'WIKA','brand':'WIKA'},
    {'pattern':'KEN','brand':'KENNEDY'},
    {'pattern':'LOC','brand':'LOCTITE'},
    {'pattern':'NOR','brand':'NORGREN'},
    {'pattern':'ROC','brand':'ROCOL'},
    {'pattern':'SMC','brand':'SMC'},
    {'pattern':'DOR','brand':'DORMER'},
    {'pattern':'FAC','brand':'FACOM'},
    {'pattern':'BAH','brand':'BAHCO'},
    {'pattern':'DRP','brand':'DRAPER'}
]

patterns_suffix = [
    {'pattern':'SYSTEMPLAST','brand':'SYSTEMPLAST'},
    {'pattern':'HUTCHINSON','brand':'HUTCHINSON'},
    {'pattern':'CONTITECH','brand':'CONTITECH'},
    {'pattern':'PERMABLOC','brand':'PERMABLOC'},
    {'pattern':'PROTORQUE','brand':'PROTORQUE'},
    {'pattern':'RINGFEDER','brand':'RINGFEDER'},
    {'pattern':'GOODYEAR','brand':'GOODYEAR'},
    {'pattern':'MEGADYNE','brand':'MEGADYNE'},
    {'pattern':'OPTIBELT','brand':'OPTIBELT'},
    {'pattern':'CAMOZZI','brand':'CAMOZZI'},
    {'pattern':'LOCTITE','brand':'LOCTITE'},
    {'pattern':'NEUTRAL','brand':'NEUTRAL'},
    {'pattern':'REXNORD','brand':'REXNORD'},
    {'pattern':'REXROTH','brand':'REXROTH'},
    {'pattern':'TSUBAKI','brand':'TSUBAKI'},
    {'pattern':'COOPER','brand':'COOPER'},
    {'pattern':'FENNER','brand':'FENNER'},
    {'pattern':'MCGILL','brand':'MCGILL'},
    {'pattern':'OILITE','brand':'OILITE'},
    {'pattern':'REGINA','brand':'REGINA'},
    {'pattern':'RENOLD','brand':'RENOLD'},
    {'pattern':'RULAND','brand':'RULAND'},
    {'pattern':'TIMKEN','brand':'TIMKEN'},
    {'pattern':'GATES','brand':'GATES'},
    {'pattern':'MECRO','brand':'MECRO'},
    {'pattern':'BANDO','brand':'BANDO'},
    {'pattern':'DODGE','brand':'DODGE'},
    {'pattern':'FESTO','brand':'FESTO'},
    {'pattern':'GATES','brand':'GATES'},
    {'pattern':'HEPCO','brand':'HEPCO'},
    {'pattern':'HIWIN','brand':'HIWIN'},
    {'pattern':'OPTI','brand':'OPTIBELT'},
    {'pattern':'TSUB','brand':'TSUBAKI'},
    {'pattern':'IGUS','brand':'IGUS'},
    {'pattern':'IWIS','brand':'IWIS'},
    {'pattern':'KOBO','brand':'KOBO'},
    {'pattern':'ASA','brand':'ASAHI'},
    {'pattern':'FAG','brand':'FAG'},
    {'pattern':'FEN','brand':'FENNER'},
    {'pattern':'INA','brand':'INA'},
    {'pattern':'NSK','brand':'NSK'},
    {'pattern':'REN','brand':'RENOLD'},
    {'pattern':'RHP','brand':'RHP'},
    {'pattern':'SKF','brand':'SKF'},
    {'pattern':'TIM','brand':'TIMKEN'},
    {'pattern':'EZO','brand':'EZO'},
    {'pattern':'FAG','brand':'FAG'},
    {'pattern':'FEN','brand':'FENNER'},
    {'pattern':'IKO','brand':'IKO'},
    {'pattern':'INA','brand':'INA'},
    {'pattern':'KTR','brand':'KTR'},
    {'pattern':'LDI','brand':'LDI'},
    {'pattern':'NSK','brand':'NSK'},
    {'pattern':'REN','brand':'RENOLD'},
    {'pattern':'RHP','brand':'RHP'},
    {'pattern':'SKF','brand':'SKF'},
    {'pattern':'THK','brand':'THK'}
]

brands_undesirable = ['RS','BRAMMER','ERIKS','HAYLEY','DRAWING', 'MINETTI', 'MINETTI SPA']
brands_desirable = ['SKF','WURTH','SIEMENS','SICK','VISHAY','PHOENIX','PANASONIC','ABB','GRUNDFOS','MOLEX',
'SCHNEIDER','OMRON','FESTO','TIMKEN','TEXAS INSTRUMENTS','SAMTEC','KEMET','SEALEY',
'EATON','IFM','EUROKRAFT','MOELLER','NSK','GEBERIT','SMC','TRACOPOWER','CARADON','MURATA',
'BOURNS','ROHM','BOSCH','AMPHENOL','NORGREN']

def cleanPart(value):
    value = re.sub(r"^\W+", "", value)
    value = re.sub(r"\W+$", "", value)
    return value


def pick_best_part(potentials):
    """
    Attempts to pick the best part from a list
    Used if there is no better information to go off
    """
    # Sort by length descending
    potentials = sorted(list(potentials), key=len, reverse=True)

    # Loop through
    # if the part contains two tokens of 5 or more chars, discard as this is probably two concatenated together
    # Otherwise return the first, i.e. longest, result
    for potential in potentials:
        tokens = potential.split()
        tokens_long_count = 0
        for token in tokens:
            if len(token) >= 5:
                tokens_long_count += 1
        
        if tokens_long_count < 2:
            return potential
                

def count_space(string):
    # counter
    count = 0
    # loop for search each index
    for i in string:
        # Check each char
        # is blank or not
        if i == " ":
            count += 1
         
    return count


def convertPartcodeToPattern(partcode):
    pattern = str(partcode).upper()
    pattern = re.sub('[^A-Z0-9]', '', pattern)
    pattern = re.sub('[A-Z]', 'A', pattern)
    pattern = re.sub('[0-9]', '#', pattern)
    return pattern

def convertPartcodeToPatternAlpha(partcode):
    pattern = str(partcode).upper()
    pattern = re.sub('[^A-Z0-9]', '', pattern)
    pattern = re.sub('[0-9]', '#', pattern)
    return pattern


def process(df, siteCode, verbose=False):
    # df = pd.read_excel(filename, engine='openpyxl', sheet_name=sheetname)
    df = df.fillna('')

    i = 0
    results = []
    for idx, row in df.iterrows():
        result = {}

        part_match = {}
        if row['match_brand']: part_match = {'brand': row['match_brand'], 'part': row['match_part'], 'pattern': row['match_part'], 'type': 'MATCH'}
        
        part_rs = {}
        if row['match_rs_brand']: part_rs = {'brand': row['match_rs_brand'], 'part': row['match_rs_part'], 'pattern': row['match_rs_part'], 'type': 'MATCH'}

        part_patterns_alpha = {}
        if row['pattern_alpha_brand']: part_patterns_alpha = {'brand': row['pattern_alpha_brand'], 'part': row['pattern_alpha_part'], 'pattern': convertPartcodeToPatternAlpha(row['pattern_alpha_part']), 'type': 'SIMILAR'}

        part_patterns = {}
        if row['patterns_brand']: part_patterns = {'brand': row['patterns_brand'], 'part': row['patterns_part'], 'pattern': convertPartcodeToPattern(row['patterns_part']), 'type': 'SIMILAR'}

        part_predict = {}
        if row['predict_brand']: part_predict = {'brand': row['predict_brand'], 'part': row['predict_part'], 'pattern': convertPartcodeToPatternAlpha(row['predict_part']), 'type': 'SIMILAR'}

        if part_match:
            result = part_match
        elif part_rs:
            result = part_rs
        elif part_patterns_alpha:
            result = part_patterns_alpha
        elif part_patterns:
            result = part_patterns
        elif part_predict:
            result = part_predict

        brands_primary = row.get('Brands Primary', [])
        if '' in brands_primary: brands_primary.remove('')

        brands_secondary = row.get('Brands Secondary', [])
        if '' in brands_secondary: brands_secondary.remove('')

        brands_all = brands_primary + brands_secondary
        brands_primary = set(brands_primary)
        brands_all = set(brands_all)

        parts_primary = row.get('Parts Primary', [])
        if '' in parts_primary: parts_primary.remove('')

        # If nothing from parts primary, but MPN has something sensible - add that
        if re.search('[0-9]', str(row.get('MPN', ''))) and len(parts_primary) == 0 and count_space(str(row.get('MPN', ''))) < 2 and len(str(row.get('MPN', ''))) < 15:
            parts_primary.append(str(row['MPN']))

        if '' in parts_primary: parts_primary.remove('')
        
        parts_secondary = row.get('Parts Secondary', [])
        if '' in parts_secondary: parts_secondary.remove('')

        parts_all = parts_primary + parts_secondary
        parts_primary = set(parts_primary)
        parts_all = set(parts_all)

        # Check the desirable brand list for a match
        if not result:
            for brand_potential in brands_all:
                if brand_potential in brands_desirable:
                    result['brand'] = brand_potential

        if not result:
            for brand_potential in brands_primary:
                if brand_potential not in brands_undesirable:
                    result['brand'] = brand_potential

        if not result:
            for brand_potential in brands_all:
                if brand_potential not in brands_undesirable:
                    result['brand'] = brand_potential
        
        if not result:
            if brands_primary:
                result['brand'] = list(brands_primary)[0]
            elif brands_all:
                result['brand'] = list(brands_all)[0]
            elif len(str(row["Manufacturer"])) > 0:
                result['brand'] = row["Manufacturer"]

        part_found = ''
        try: 
            part_found = result['part']
        except:
            pass
        
        if not part_found:
            try:
                part_found = pick_best_part(parts_primary)
            except:
                pass
        
        if not part_found:
            try:
                part_found = pick_best_part(parts_all)
            except:
                pass
        
        if part_found:
            result['part'] = part_found

        if result:
            # Pass for part code prefix or suffix
            for pattern_prefix in patterns_prefix:
                try:
                    if re.match(pattern_prefix['pattern'], str(result['part'])):
                        result['brand'] = pattern_prefix['brand']
                        result['part'] = result['part'].replace(pattern_prefix['pattern'], '')
                except:
                    pass

            for pattern_suffix in patterns_suffix:
                try:
                    if re.search(pattern_suffix['pattern'] + '$', str(result['part'])):
                        result['brand'] = pattern_suffix['brand']
                        result['part'] = result['part'].replace(pattern_suffix['pattern'], '')
                except:
                    pass
            
            # Clean special chars before/after
            try:
                result['part'] = cleanPart(result['part'])
            except:
                pass

            # Replace Shaanxi - appears to be a supplier to RS
            try:
                if result['brand'] == 'SHAANXI MACHINERY & EQUIPMENT':
                    for brand_potential in brands_all:
                        if brand_potential in brands_desirable:
                            result['brand'] = brand_potential
            except:
                pass

            # Standardise Brands
            try:
                result['brand'] = brand_variants.get(result['brand'], result['brand'])
            except:
                pass

            i += 1
        
        if verbose: print(idx, ' | ', result)

        results.append([row['ID'], result.get('brand',''), result.get('part',''), result.get('pattern', ''), result.get('type', 'NONE')])

    df_results = pd.DataFrame(results, columns=['ID', 'Brand', 'Part Number', 'Pattern', 'Type'])
    df_results = df_results[['Brand', 'Part Number', 'Pattern', 'Type']]
    # df_results.to_excel('output/' + siteCode + '-merge.xlsx', engine='openpyxl', index=False)
    
    print('Total: ', i)
    return df_results